/*
 * chkndp.c:
 *
 * Copyright (c) 2002 James McKenzie <james@fishsoup.dhs.org>,
 * All rights reserved.
 *
 */

static char rcsid[] = "$Id: chkndp.c,v 1.3 2002/06/12 11:12:43 root Exp $";

/*
 * $Log: chkndp.c,v $
 * Revision 1.3  2002/06/12 11:12:43  root
 * #
 *
 * Revision 1.2  2002/06/12 11:12:32  root
 * #
 *
 * Revision 1.1  2002/06/12 10:54:53  root
 * Initial revision
 *
 */

#include <stdio.h>
#include <stdlib.h>

static void
fish (void)
{
  fprintf (stderr, "brkndp - pop\n");
  return;
}

static float
soup (void)
{
  fprintf (stderr, "brkndp - push\n");
  return 1.0;
}

void
brkndp (int i)
{
  if (i > 0)
    {
      while (i--)
        (*(void (*)(void)) &soup) ();
      return;
    }

  while (i++)
    (*(float (*)(void)) &fish) ();

}

void
brkndp_ (int *i)
{
  brkndp (*i);
}

void
chkndp (void)
{
  int a;

  asm __volatile__ ("xor %%eax,%%eax\nfstsw %%ax\n":"=a" (a));

  a &= 0xffff;

  if (!(a & 0x3840))
    return;

  fprintf (stderr, "%c%c%c%c******************************************\n", 7,
           7, 7, 7);
  fprintf (stderr, "NDP reports the following:\n");

  if (a & 0x3800)
    {
      int tos = (a & 0x3800) >> 11;
      fprintf (stderr, "  tos pointer = %d (should be 0)\n", tos);
      fprintf (stderr, "     either %d extra pushes or %d extra pops\n",
               8 - tos, tos);
    }
  if (a & 0x1)
    fprintf (stderr, "  Invalid operation\n");
  if (a & 0x2)
    fprintf (stderr, "  Result denormalized\n");
  if (a & 0x4)
    fprintf (stderr, "  Divide by zero\n");
  if (a & 0x8)
    fprintf (stderr, "  Overflow\n");
  if (a & 0x10)
    fprintf (stderr, "  Underflow\n");
  if (a & 0x20)
    fprintf (stderr, "  Precision lost\n");
  if (a & 0x40)
    {
      if (a & 0x200)
        {
          fprintf (stderr, "  Stack overflow  (At some point)\n");
        }
      else
        {
          fprintf (stderr, "  Stack underflow (At some point)\n");
        }
    }

  if (a & 0x80)
    fprintf (stderr, "  Error\n");

  fprintf (stderr, "%c%c%c%c******************************************\n", 7,
           7, 7, 7);
  fprintf (stderr, "chkndp - Now coredumping\n");
  abort ();
}

void
chkndp_ (void)
{
  chkndp ();
}
